% MELF 

function y_LPA_FOR = MELF_Filter(y, n_0, n_K, b_K, b_c, c, r_rho, i_0, H, Observed_Volume, Seasonal_Factor, Data_Matrix)

b_intervals = load('b_intervals');
y_T = EACD_11_Test_Statistic_b_zk_Filter(y(i_0 : 1800 + i_0, 1), c);
y_k_hat = sum(y_T < 100000);
y_n_hat = b_intervals(y_k_hat + 1, 2);
y_theta_hat = EACD_11_Estimation_Test_Statistic_Est_and_Lik_Filter(y(i_0 : i_0 + y_n_hat - 1, 1));
y_mut = ones(1800 + H, 1);
for t = 2 : 1 : 1801
  y_mut(t, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y(t + i_0 - 2, 1) + y_theta_hat(3, 1) * y_mut(t - 1, 1);
end
y_for = zeros(H, 1);
y_for(1, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y(1800 + i_0 - 1, 1) + y_theta_hat(3, 1) * y_mut(1800, 1);
for h = 2 : 1 : H
  y_mut(1800 + h, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y_for(h - 1, 1) + y_theta_hat(3, 1) * y_mut(1800 + h - 1, 1);
  y_for(h, 1) = y_theta_hat(1, 1) + y_theta_hat(2, 1) * y_for(h - 1, 1) + y_theta_hat(3, 1) * y_mut(1800 + h - 1, 1);
end
y_LPA_FOR = vertcat(Data_Matrix(i_0, 1), Data_Matrix(i_0, 2), Data_Matrix(i_0 + 1799, 1), Data_Matrix(i_0 + 1799, 2), Data_Matrix(i_0 + 1800, 1), Data_Matrix(i_0 + 1800, 2), Data_Matrix(i_0 + 1859, 1), Data_Matrix(i_0 + 1859, 2), n_0, n_K, b_K, b_c, r_rho, i_0, y_k_hat, y_n_hat, y_theta_hat, y_T, Observed_Volume(i_0 : 1800 + i_0 - 1 + H, 1), vertcat(y_mut(1 : 1800, 1), y_for) .* Seasonal_Factor(i_0 : 1800 + i_0 - 1 + H, 1));

end


