

% SIN_EACD_11_Critical_Values_5_Test_Statistics

% 5. Test Statistics

function Out = SIN_EACD_11_Critical_Values_5_Test_Statistics(y, b_K)

% Input
SIN_Intervals = load('SIN_Intervals');  % Interval selection
% SIN_EACD_11_Estimation_Likelihood.m
% SIN_EACD_11_Test_Statistics_Sort.m

% Programme Code
b_y_Jk = cell(b_K - 1, 1); b_o_Jk = cell(b_K - 1, 1); b_L3 = zeros(b_K - 1, 1);
b_L11 = zeros(b_K - 1, 1); b_L21 = zeros(b_K - 1, 1);
b_L12 = zeros(b_K - 1, 1); b_L22 = zeros(b_K - 1, 1);
b_L13 = zeros(b_K - 1, 1); b_L23 = zeros(b_K - 1, 1);
for k = 1 : 1 : b_K - 1
  b_y_Jk{k} = y(SIN_Intervals(k + 1, 3) : SIN_Intervals(k + 1, 4));
  b_o_Jk{k} = SIN_EACD_11_Test_Statistics_Sort(b_y_Jk{k});
  b_L11(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k})) - 2));
  b_L12(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 1) - 2));
  b_L13(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 2) - 2));
  b_L21(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k})) - 1 : end));
  b_L22(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 1) - 1 : end));
  b_L23(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 3) + b_o_Jk{k}(length(b_o_Jk{k}) - 2) - 1 : end));
  b_L3(k) = SIN_EACD_11_Estimation_Likelihood(y(SIN_Intervals(k + 1, 5) : end));
end
b_T1 = b_L11 + b_L21 - b_L3; b_T2 = b_L12 + b_L22 - b_L3; b_T3 = b_L13 + b_L23 - b_L3;
b_T1T2T3 = [b_T1, b_T2, b_T3]; b_T = max(b_T1T2T3, [], 2);

% Output
Out = b_T;

end


